//+------------------------------------------------------------------+
//|                                                     ADX Rene.mq4 |
//|                     
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#define MAGIC 007


extern bool AutoOrder = false;
extern double TakeProfit = 60;
extern double Lots =1;
extern double TrailingStop = 0;
extern double StopLoss = 30;
extern bool UseSound = True;
extern bool UseAlert = True;
extern string NameFileSound = "alert.wav";

double b4plusdi,nowplusdi,b4minusdi,nowminusdi;
int Timeminutesbuffer;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int init()
  {
 Timeminutesbuffer = TimeMinute (Time[0]); 
  }
  
int start()
  {  
    double ADXP, ADXC, ADXDIPP;
    double ADXDIPC, ADXDIMP, ADXDIMC;
    int cnt, ticket, total;
    int ticketBuy =0;
    bool Openordersclosed= true;
    
   int i;
   int shift = 1;
   
    if(TakeProfit < 10)
      {
        Alert("EA: TakeProfit less than 10");
        return(0);  // check TakeProfit
      }
  
  
   b4plusdi  =iADX(Symbol(),0,14,PRICE_CLOSE,MODE_PLUSDI,1);
	nowplusdi =iADX(Symbol(),0,14,PRICE_CLOSE,MODE_PLUSDI,0);
	b4minusdi =iADX(Symbol(),0,14,PRICE_CLOSE,MODE_MINUSDI,1);
	nowminusdi=iADX(Symbol(),0,14,PRICE_CLOSE,MODE_MINUSDI,0); 
	


   //Alert(Timeminutesbuffer,"-buy-",TimeMinute (Time[0] ),":"+b4plusdi+":"+nowplusdi+":"+b4minusdi+":"+nowminusdi+":");
	
 /*   ADXP = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MAIN, 2);
    ADXC = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MAIN, 1);
    
    ADXDIPP = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_PLUSDI, 2);
    ADXDIPC = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_PLUSDI, 1);  
    
    ADXDIMP = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MINUSDI, 2);
    ADXDIMC = iADX(NULL, 0, 14, PRICE_CLOSE, MODE_MINUSDI, 1);  
    */
 //Alert(Timeminutesbuffer , " -- ", TimeMinute (Time[0] ));  
 
 
if (b4plusdi<b4minusdi && nowplusdi>nowminusdi) 
{ 
 //  Alert(Timeminutesbuffer,"-buy-",TimeMinute (Time[0] ));
   
	if( Timeminutesbuffer < TimeMinute (Time[0] ))
  {
	if (UseSound==1) PlaySound(NameFileSound);
	if (UseAlert==1) Alert("EA: Buy signal at Ask: "+Ask  +" - "+Symbol());
	           
	       //    if (AutoOrder == true) 
	         //  {
	           Openordersclosed = CheckandCloseOpenOrder(OP_SELL);
	     
	           if (Openordersclosed == true )
	           {
	           ticketBuy=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,Ask-StopLoss*Point,Ask+TakeProfit*Point,"BD buy Start Trend",0,0,Green);
                                        
     
                if(ticket<0)
                  {
                   Alert("EA: Buy OrderSend failed with error #",GetLastError() +" - "+Symbol());                   
                  }
                  else
                  {    
                   PlaySound("alert.wav");
                   Alert("EA: Order Open Buy - "+Symbol());
                  }
                  
              }
              else 
              {
              Alert("EA: Sell OrderClose failed with error #",GetLastError() +" - "+Symbol());
              }                      
	         //  }//Auto Order True
	
	 Timeminutesbuffer = TimeMinute (Time[0]); 
   }//Timebuffer End
}





 if (b4plusdi>b4minusdi && nowplusdi<nowminusdi)
{	

  // Alert(Timeminutesbuffer,"-sell-",TimeMinute (Time[0] ));
   
	if( Timeminutesbuffer < TimeMinute (Time[0] ))
  {
	if (UseSound==1) PlaySound(NameFileSound);
	if (UseAlert==1) Alert("EA: Sell signal at Bid: "+Bid  +" - "+Symbol());

          /*  if (AutoOrder == true) 
	           {*/	
	           Openordersclosed = CheckandCloseOpenOrder(OP_BUY);
	     
	              if (Openordersclosed == true  )
	              {
	              ticketBuy=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,Bid+StopLoss*Point,Bid-TakeProfit*Point,"BD Sell Start Trend",0,0,Red);
                 
                        if(ticket<0)
                          {
                           Alert("EA: Sell OrderSend failed with error #",GetLastError() +" - "+Symbol());
                          }   
                          else
                          {    
                           PlaySound("alert.wav");
                           Alert("EA: Order Open Sell - "+Symbol());
                          }

	              } //Open Orders closed
	             else 
	             {
	             Alert("EA: Buy Order Close failed with error #",GetLastError() +" - "+Symbol());
	             }
	            
	        //   }//Auto Order True
	
	 Timeminutesbuffer = TimeMinute (Time[0]); 
   }//Timebuffer End
}
    
    
   /*  if((ADXP < ADXC) && (ADXDIPP < ADXP) && (ADXDIPC > ADXC))
          {//Buy
          Alert("Make a Buy : " +OrderOpenPrice());
          PlaySound("alert.wav");
          }
   
          
        if((ADXP < ADXC) && (ADXDIMP < ADXP) && (ADXDIMC > ADXC))
          {//Sell
            Alert("Make a Sell : "+OrderOpenPrice());
            PlaySound("alert.wav");
          }
                */
          
//----
   return(0);
  }
  

  int CheckandCloseOpenOrder(int OrderTyp)
  {  
  int i =0;
  bool OrderResult= true;
  int count = 0;
  string Orderstr = "";
  

  int cnt = OrdersTotal ();
     
     for ( i=0; i <cnt; i ++) 
     {
      if (! OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
      if (OrderType () == OrderTyp && OrderSymbol()==Symbol() ) count ++;
     }
    
 if (count >0)
  {
  
  if  ( OrderTyp == OP_BUY ) Orderstr ="BUY"; 
  if  ( OrderTyp == OP_SELL ) Orderstr ="SELL"; 
      
   Alert("EA: Es sind ",count," Order vom Typ "+Orderstr+" offen - "+Symbol() );
 
 
  for ( i=count-1; i>=0; i--) 
  {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
    {
      if (OrderMagicNumber()==MAGIC ) 
      {
        if (OrderSymbol()== Symbol() ) 
        {
               if (OrderType()==OP_BUY ) 
               {
              OrderResult =  OrderClose(MAGIC,Lots,Bid,CLR_NONE );
               }
          
               if (OrderType()==OP_SELL)
               {
              OrderResult =  OrderClose(MAGIC,Lots,Ask,CLR_NONE );
               }
        }
      }
    }  
 }
 
 }//Order Count grer 0
 
 return(OrderResult);
 }

//+------------------------------------------------------------------+